diff --git a/tests/test_hub/test_update_notification.py b/tests/test_hub/test_update_notification.py
new file mode 100644
index 0000000..f08d8c5
--- /dev/null
+++ b/tests/test_hub/test_update_notification.py
@@ -0,0 +1,148 @@
+import mock
+import unittest
+
+import koji
+import kojihub
+
+QP = kojihub.QueryProcessor
+IP = kojihub.InsertProcessor
+UP = kojihub.UpdateProcessor
+
+
+class TestUpdateNotifications(unittest.TestCase):
+    def getInsert(self, *args, **kwargs):
+        insert = IP(*args, **kwargs)
+        insert.execute = mock.MagicMock()
+        self.inserts.append(insert)
+        return insert
+
+    def getQuery(self, *args, **kwargs):
+        query = QP(*args, **kwargs)
+        query.execute = mock.MagicMock()
+        self.queries.append(query)
+        return query
+
+    def getUpdate(self, *args, **kwargs):
+        update = UP(*args, **kwargs)
+        update.execute = mock.MagicMock()
+        self.updates.append(update)
+        return update
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.context.opts = {
+            'EmailDomain': 'test.domain.com',
+            'NotifyOnSuccess': True,
+        }
+
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
+                                         side_effect=self.getQuery).start()
+        self.queries = []
+        self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
+                                          side_effect=self.getInsert).start()
+        self.inserts = []
+        self.UpdateProcessor = mock.patch('kojihub.UpdateProcessor',
+                                          side_effect=self.getUpdate).start()
+        self.updates = []
+        self.get_build_notifications = mock.patch('kojihub.get_build_notifications').start()
+        self.get_tag_id = mock.patch('kojihub.get_tag_id').start()
+        self.get_package_id = mock.patch('kojihub.get_package_id').start()
+
+        self.exports = kojihub.RootExports()
+        self.exports.getLoggedInUser = mock.MagicMock()
+        self.exports.hasPerm = mock.MagicMock()
+        self.exports.getBuildNotification = mock.MagicMock()
+        self.user_id = 1
+        self.n_id = 5432
+        self.package_id = 234
+        self.tag_id = 345
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_updateNotification(self):
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 1}
+        self.exports.hasPerm.return_value = True
+        self.get_package_id.return_value = self.package_id
+        self.get_tag_id.return_value = self.tag_id
+        self.get_build_notifications.return_value = [{
+            'tag_id': self.tag_id,
+            'user_id': self.user_id,
+            'package_id': self.package_id,
+            'success_only': not success_only,
+        }]
+        self.exports.getBuildNotification.return_value = {'user_id': self.user_id}
+
+        r = self.exports.updateNotification(self.n_id, self.package_id, self.tag_id, success_only)
+        self.assertEqual(r, None)
+
+        self.exports.getLoggedInUser.assert_called_once()
+        self.exports.hasPerm.asssert_called_once_with('admin')
+        self.get_package_id.assert_called_once_with(self.package_id, strict=True)
+        self.get_tag_id.assert_called_once_with(self.tag_id, strict=True)
+        self.get_build_notifications.assert_called_once_with(self.user_id)
+        self.assertEqual(len(self.inserts), 0)
+        self.assertEqual(len(self.updates), 1)
+
+    def test_updateNotification_not_logged(self):
+        success_only = True
+        self.exports.getLoggedInUser.return_value = None
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.updateNotification(self.n_id, self.package_id, self.tag_id, success_only)
+        self.assertEqual('Not logged-in', str(cm.exception))
+
+        self.assertEqual(len(self.inserts), 0)
+        self.assertEqual(len(self.updates), 0)
+
+    def test_updateNotification_missing(self):
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 1}
+        self.exports.getBuildNotification.side_effect = koji.GenericError
+
+        with self.assertRaises(koji.GenericError):
+            self.exports.updateNotification(self.n_id, self.package_id, self.tag_id, success_only)
+
+        self.assertEqual(len(self.inserts), 0)
+        self.assertEqual(len(self.updates), 0)
+
+    def test_updateNotification_no_perm(self):
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 132}
+        self.exports.getBuildNotification.return_value = {'user_id': self.user_id}
+        self.exports.hasPerm.return_value = False
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.updateNotification(self.n_id, self.package_id, self.tag_id, success_only)
+        self.assertEqual(f'user 132 cannot update notifications for user {self.user_id}',
+                         str(cm.exception))
+
+        self.assertEqual(len(self.inserts), 0)
+        self.assertEqual(len(self.updates), 0)
+
+    def test_updateNotification_exists(self):
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 1}
+        self.exports.hasPerm.return_value = True
+        self.get_package_id.return_value = self.package_id
+        self.get_tag_id.return_value = self.tag_id
+        self.get_build_notifications.return_value = [{
+            'tag_id': self.tag_id,
+            'user_id': self.user_id,
+            'package_id': self.package_id,
+            'success_only': success_only,
+        }]
+        self.exports.getBuildNotification.return_value = {'user_id': self.user_id}
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.updateNotification(self.n_id, self.package_id, self.tag_id, success_only)
+        self.assertEqual('notification already exists', str(cm.exception))
+
+        self.exports.getLoggedInUser.assert_called_once()
+        self.exports.hasPerm.asssert_called_once_with('admin')
+        self.get_package_id.assert_called_once_with(self.package_id, strict=True)
+        self.get_tag_id.assert_called_once_with(self.tag_id, strict=True)
+        self.get_build_notifications.assert_called_once_with(self.user_id)
+        self.assertEqual(len(self.inserts), 0)
+        self.assertEqual(len(self.updates), 0)
diff --git a/tests/test_hub/test_win_build.py b/tests/test_hub/test_win_build.py
new file mode 100644
index 0000000..a2adcd7
--- /dev/null
+++ b/tests/test_hub/test_win_build.py
@@ -0,0 +1,68 @@
+import unittest
+import koji
+import kojihub
+import mock
+
+
+class TestWinBuild(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertLogin = mock.MagicMock()
+        self.context.session.hasPerm = mock.MagicMock()
+        self.get_channel = mock.patch('kojihub.get_channel').start()
+        self.assert_policy = mock.patch('kojihub.assert_policy').start()
+        self.get_build_target = mock.patch('kojihub.get_build_target').start()
+        self.make_task = mock.patch('kojihub.make_task').start()
+        self.vm = 'test-vm'
+        self.url = 'https://test-url.com'
+        self.target = 'test-target'
+        self.targetinfo = {'build_tag': 444,
+                           'build_tag_name': 'test-tag',
+                           'dest_tag': 445,
+                           'dest_tag_name': 'dest-test-tag',
+                           'id': 1,
+                           'name': self.target}
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_win_not_supported(self):
+        self.context.opts.get.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.winBuild(self.vm, self.url, self.target)
+        self.assertEqual("Windows support not enabled", str(cm.exception))
+
+    def test_vm_wrong_type(self):
+        vm = ['test-vm']
+        self.context.opts.get.return_value = True
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.winBuild(vm, self.url, self.target)
+        self.assertEqual(f"Invalid type for value '{vm}': {type(vm)}", str(cm.exception))
+
+    def test_url_wrong_type(self):
+        url = ['test-url']
+        self.context.opts.get.return_value = True
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.winBuild(self.vm, url, self.target)
+        self.assertEqual(f"Invalid type for value '{url}': {type(url)}", str(cm.exception))
+
+    def test_priority_without_admin(self):
+        priority = -10
+        self.context.opts.get.return_value = True
+        self.get_build_target.return_value = self.targetinfo
+        self.assert_policy.return_value = True
+        self.context.session.hasPerm.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.winBuild(self.vm, self.url, self.target, priority=priority)
+        self.assertEqual("only admins may create high-priority tasks", str(cm.exception))
+
+    def test_channel_not_str(self):
+        self.context.opts.get.return_value = True
+        self.get_build_target.return_value = self.targetinfo
+        self.assert_policy.return_value = True
+        self.make_task.return_value = 123
+        self.get_channel.return_value = {'comment': None, 'description': None, 'enabled': True,
+                                         'id': 1, 'name': 'vm'}
+        self.exports.winBuild(self.vm, self.url, self.target, channel=1, priority=10)
diff --git a/tests/test_hub/test_wrapper_rpm.py b/tests/test_hub/test_wrapper_rpm.py
new file mode 100644
index 0000000..0698285
--- /dev/null
+++ b/tests/test_hub/test_wrapper_rpm.py
@@ -0,0 +1,56 @@
+import unittest
+import koji
+import kojihub
+import mock
+
+
+class TestWrapperRPM(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertLogin = mock.MagicMock()
+        self.context.session.hasPerm = mock.MagicMock()
+        self.get_channel = mock.patch('kojihub.get_channel').start()
+        self.exports.getBuild = mock.MagicMock()
+        self.make_task = mock.patch('kojihub.make_task').start()
+        self.list_rpms = mock.patch('kojihub.list_rpms').start()
+        self.exports.getTag = mock.MagicMock()
+        self.exports.getBuildTarget = mock.MagicMock()
+        self.exports.getRepo = mock.MagicMock()
+        self.build = 'testbuild-1-1.4'
+        self.target = 'test-target'
+        self.url = 'https://test-url.com'
+        self.buildinfo = {'name': 'testbuild', 'version': '1', 'release': '1.4',
+                          'nvr': self.build, 'id': 123}
+        self.targetinfo = {'build_tag': 444,
+                           'build_tag_name': 'test-tag',
+                           'dest_tag': 445,
+                           'dest_tag_name': 'dest-test-tag',
+                           'id': 1,
+                           'name': self.target}
+        self.taginfo = {'id': 159, 'name': 'test-tag'}
+        self.repoinfo = {'id': 753}
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_url_wrong_type(self):
+        url = ['test-url']
+        self.context.opts.get.return_value = True
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.wrapperRPM(self.build, url, self.target)
+        self.assertEqual(f"Invalid type for value '{url}': {type(url)}", str(cm.exception))
+
+    def test_channel_not_str(self):
+        priority = 10
+        self.context.opts.get.return_value = True
+        self.exports.getBuild.return_value = self.buildinfo
+        self.list_rpms.return_value = []
+        self.exports.getBuildTarget.return_value = self.targetinfo
+        self.exports.getRepo.return_value = self.taginfo
+        self.exports.getRepo.return_value = self.repoinfo
+        self.make_task.return_value = 123
+        self.get_channel.return_value = {'comment': None, 'description': None, 'enabled': True,
+                                         'id': 2, 'name': 'maven'}
+        self.exports.wrapperRPM(self.build, self.url, self.target, priority=priority, channel=2)
diff --git a/tests/test_hub/test_write_signed_rpm.py b/tests/test_hub/test_write_signed_rpm.py
new file mode 100644
index 0000000..818ea22
--- /dev/null
+++ b/tests/test_hub/test_write_signed_rpm.py
@@ -0,0 +1,23 @@
+import unittest
+import mock
+
+import koji
+import kojihub
+
+
+class TestWriteSignedRPM(unittest.TestCase):
+    def setUp(self):
+        self.get_rpm = mock.patch('kojihub.get_rpm').start()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_write_signed_rpm_not_internal_rpm(self):
+        sigkey = 'test-sigkey'
+        rpm_id = 1
+        rpminfo = {'external_repo_id': 1, 'external_repo_name': 'test-external-repo'}
+        self.get_rpm.return_value = rpminfo
+        with self.assertRaises(koji.GenericError) as cm:
+            kojihub.write_signed_rpm(rpm_id, sigkey)
+        self.assertEqual(f"Not an internal rpm: {rpm_id} (from {rpminfo['external_repo_name']})",
+                         str(cm.exception))
diff --git a/tests/test_plugins/test_runroot_hub.py b/tests/test_plugins/test_runroot_hub.py
index f78b2e0..14d7874 100644
--- a/tests/test_plugins/test_runroot_hub.py
+++ b/tests/test_plugins/test_runroot_hub.py
@@ -48,8 +48,8 @@ class TestRunrootHub(unittest.TestCase):
         context.handlers = mock.MagicMock()
         context.handlers.call = mock.MagicMock()
         context.handlers.call.side_effect = [
-            {'id': 2, 'name': 'runroot'}, # getChannel
-            [ # listHosts
+            {'id': 2, 'name': 'runroot'},  # getChannel
+            [  # listHosts
                 {
                     'arches': 'i386 x86_64',
                     'capacity': 20.0,
@@ -105,8 +105,8 @@ class TestRunrootHub(unittest.TestCase):
         context.handlers = mock.MagicMock()
         context.handlers.call = mock.MagicMock()
         context.handlers.call.side_effect = [
-            {'id': 2, 'name': 'runroot'}, # getChannel
-            [ # listHosts
+            {'id': 2, 'name': 'runroot'},  # getChannel
+            [  # listHosts
                 {
                     'arches': 'i386 x86_64',
                     'capacity': 20.0,
@@ -147,3 +147,31 @@ class TestRunrootHub(unittest.TestCase):
             mock.call('listHosts', channelID=2, enabled=True),
         ])
         make_task.assert_not_called()
+
+    @mock.patch('kojihub.get_channel')
+    @mock.patch('kojihub.get_tag')
+    @mock.patch('kojihub.make_task')
+    @mock.patch('runroot_hub.context')
+    def test_non_exist_channel(self, context, make_task, get_tag, get_channel):
+        context.session.assertPerm = mock.MagicMock()
+        get_channel.side_effect = koji.GenericError
+        with self.assertRaises(koji.GenericError):
+            runroot_hub.runroot(tagInfo='some_tag', arch='x86_64', command='ls',
+                                channel='non-exist-channel')
+        make_task.assert_not_called()
+        get_tag.assert_not_called()
+
+    @mock.patch('kojihub.get_channel')
+    @mock.patch('kojihub.get_tag')
+    @mock.patch('kojihub.make_task')
+    @mock.patch('runroot_hub.context')
+    def test_commang_wrong_format(self, context, make_task, get_tag, get_channel):
+        context.session.assertPerm = mock.MagicMock()
+        command = ['ls']
+        with self.assertRaises(koji.GenericError) as ex:
+            runroot_hub.runroot(tagInfo='some_tag', arch='x86_64', command=command,
+                                channel='non-exist-channel')
+        self.assertEqual(f"Invalid type for value '{command}': {type(command)}", str(ex.exception))
+        make_task.assert_not_called()
+        get_tag.assert_not_called()
+        get_channel.assert_not_called()
diff --git a/util/koji-gc b/util/koji-gc
index 79d589f..6013c27 100755
--- a/util/koji-gc
+++ b/util/koji-gc
@@ -168,6 +168,8 @@ def get_options():
     # figure out actions
     actions = ('prune', 'trash', 'delete', 'salvage')
     if options.action:
+        if not isinstance(options.action, str):
+            raise koji.ParameterError('Invalid type of action: %s' % type(options.action))
         options.action = options.action.lower().replace(',', ' ').split()
         for x in options.action:
             if x not in actions:
@@ -177,6 +179,9 @@ def get_options():
 
     # split patterns for unprotected keys
     if options.unprotected_keys:
+        if not isinstance(options.unprotected_keys, str):
+            raise koji.ParameterError('Invalid type of unprotected_keys: %s'
+                                      % type(options.unprotected_keys))
         options.unprotected_key_patterns = options.unprotected_keys.replace(',', ' ').split()
     else:
         options.unprotected_key_patterns = []
@@ -250,10 +255,15 @@ def check_tag(name):
     Returns True if we should process the tag, False otherwise
     """
     if options.ignore_tags:
+        if not isinstance(options.ignore_tags, list):
+            raise koji.ParameterError('Invalid type of ignore_tags: %s'
+                                      % type(options.ignore_tags))
         for pattern in options.ignore_tags:
             if fnmatch.fnmatch(name, pattern):
                 return False
     if options.tag_filter:
+        if not isinstance(options.tag_filter, list):
+            raise koji.ParameterError('Invalid type of tag_filter: %s' % type(options.tag_filter))
         for pattern in options.tag_filter:
             if fnmatch.fnmatch(name, pattern):
                 return True
@@ -270,6 +280,8 @@ def check_package(name):
     Returns True if we should process the package, False otherwise
     """
     if options.pkg_filter:
+        if not isinstance(options.pkg_filter, list):
+            raise koji.ParameterError('Invalid type of pkg_filter: %s' % type(options.pkg_filter))
         for pattern in options.pkg_filter:
             if fnmatch.fnmatch(name, pattern):
                 return True
@@ -417,13 +429,21 @@ Build: %%(name)s-%%(version)s-%%(release)s
         msg['Subject'] = "1 build marked for deletion"
     else:
         msg['Subject'] = "%i builds marked for deletion" % len(builds)
+    if not isinstance(options.from_addr, str):
+        raise koji.ParameterError('Invalid type of from_addr: %s' % type(options.from_addr))
     msg['From'] = options.from_addr
+    if not isinstance(options.email_domain, str):
+        raise koji.ParameterError('Invalid type of email_domain: %s' % type(options.email_domain))
     msg['To'] = "%s@%s" % (owner_name, options.email_domain)  # XXX!
     emails = [msg['To']]
     if options.cc_addr:
+        if not isinstance(options.cc_addr, str):
+            raise koji.ParameterError('Invalid type of cc_addr: %s' % type(options.cc_addr))
         msg['Cc'] = ','.join(options.cc_addr)
         emails += options.cc_addr
     if options.bcc_addr:
+        if not isinstance(options.bcc_addr, str):
+            raise koji.ParameterError('Invalid type of bcc_addr: %s' % type(options.bcc_addr))
         emails += options.bcc_addr
     msg['X-Koji-Builder'] = owner_name
     if options.test:
@@ -894,6 +914,9 @@ def handle_prune():
         bypass = False
         if taginfo['locked']:
             if options.bypass_locks:
+                if not isinstance(options.bypass_locks, list):
+                    raise koji.ParameterError('Invalid type of bypass_locks: %s'
+                                              % type(options.bypass_locks))
                 for pattern in options.bypass_locks:
                     if fnmatch.fnmatch(tagname, pattern):
                         bypass = True
diff --git a/util/koji-shadow b/util/koji-shadow
index 0f25329..211d7ad 100755
--- a/util/koji-shadow
+++ b/util/koji-shadow
@@ -389,6 +389,8 @@ class TrackedBuild(object):
             log("Downloading %s" % url)
             # XXX - this is not really the right place for this
             resp = request_with_retry().get(url, stream=True)
+            if not isinstance(options.workpath, str):
+                raise koji.ParameterError('Invalid type of workpath: %s' % type(options.workpath))
             fn = "%s/%s.src.rpm" % (options.workpath, self.nvr)
             koji.ensuredir(os.path.dirname(fn))
             try:
diff --git a/util/koji-sidetag-cleanup b/util/koji-sidetag-cleanup
index a881a21..1bdc6d3 100644
--- a/util/koji-sidetag-cleanup
+++ b/util/koji-sidetag-cleanup
@@ -141,6 +141,11 @@ def activate_session(session):
     elif options.keytab and options.principal:
         try:
             if options.keytab and options.principal:
+                if not isinstance(options.keytab, str):
+                    raise koji.ParameterError('Invalid type of keytab: %s' % type(options.keytab))
+                if not isinstance(options.principal, str):
+                    raise koji.ParameterError('Invalid type of principal: %s'
+                                              % type(options.principal))
                 session.gssapi_login(
                     principal=options.principal,
                     keytab=options.keytab,

